#include "option_parser.h"

/* print the correct usage of the program */
void printUsage()
{
	printf("[-i FILE] [-x] [-y] [-g]\n\n");

	printf(" -i\tINPUT\n");
	printf(" -x\tcell widths\n");
	printf(" -y\tcell heights\n");
	printf(" -g\tgroup size\n\n");
}

/* create an 'Options' struct out of the cmd parameters */
Options parseOptions(int argc, char **argv)
{
	int opt, nrOfArguments;
	Options options;
	
	nrOfArguments = 0;

	/* no parameters given */
	if( argc == 1 )
	{
		printUsage();
		exit(1);
	}

	/* get all the parameters */
	while( (opt = getopt(argc, argv, "i:x:y:g:h:") ) != -1 )
	{
		switch(opt)
		{
			case 'h':
				printUsage();
				exit(0);;
			case 'x':
				options.cell_width = atoi(optarg);
				nrOfArguments++;
				break;
			case 'y':
				options.cell_height = atoi(optarg);
				nrOfArguments++;
				break;
			case 'g':
				options.group_size = atoi(optarg);
				nrOfArguments++;
				break;
			case 'i':
				strcpy(options.input, optarg);
				nrOfArguments++;
				break;
			case '?':
				printUsage();
				exit(1);
		}
	}

	/* not enough parameters given */
	if ( nrOfArguments != NR_OF_ARGUMENTS )
	{
		printUsage();
		exit(1);
	}
	return options;
}
